"use strict";
var __importDefault =
  (this && this.__importDefault) ||
  function (mod) {
    return mod && mod.__esModule ? mod : { default: mod };
  };
const clean_css_1 = __importDefault(require("clean-css"));
const loader_utils_1 = require("loader-utils");
const schema_utils_1 = require("schema-utils");
const schema_json_1 = __importDefault(require("./schema.json"));
function cleanCssLoader(content, prevSourceMap, additionalData) {
  const callback = this.async();
  const loaderOptions = (0, loader_utils_1.getOptions)(this) || {};
  (0, schema_utils_1.validate)(schema_json_1.default, loaderOptions, {
    name: "group-css-media-queries-loader",
  });
  const { sourceMap, disable, skipWarn, ...options } = loaderOptions;
  const useSourceMap =
    sourceMap !== null && sourceMap !== void 0 ? sourceMap : this.sourceMap;
  if (disable) {
    return callback(null, content, prevSourceMap, additionalData);
  }
  new clean_css_1.default({
    returnPromise: true,
    ...options,
  })
    .minify(
      content,
      useSourceMap
        ? prevSourceMap === null || prevSourceMap === void 0
          ? void 0
          : prevSourceMap.toString()
        : undefined
    )
    .then((output) => {
      if (!skipWarn && Array.isArray(output.warnings)) {
        output.warnings.forEach((warning) => {
          this.emitWarning(new Error(warning));
        });
      }
      return callback(
        null,
        output.styles,
        useSourceMap ? output.sourceMap.toString() : undefined,
        additionalData
      );
    })
    .catch(callback);
}
module.exports = cleanCssLoader;
